/**
 * Combined Image Copy Function
 */

import meow from '../../config.json';
import gulp from 'gulp';
import gutil from 'gulp-util';
import gulpLoadPlugins from 'gulp-load-plugins';
import pngquant from 'imagemin-pngquant';
import svgo from 'imagemin-svgo';
import jpegCompress from 'imagemin-jpeg-recompress';

const $ = gulpLoadPlugins();

const copyImages = (srcfiles, distfiles) => {
  gulp
    .src(srcfiles + '**/*.{png,jpeg,jpg,gif,webp,svg}')
    .pipe(
      global.checkChanged === true ? $.changed(meow.dist.bitmaps) : gutil.noop()
    )
    .pipe(gulp.dest(distfiles));
};

export default copyImages;
